#define PLUGINNAME	"Forum mod"
#define VERSION		"0.7.2"
#define AUTHOR		"JGHG"

/*
Copyleft 2004-2005
Plugin topic: http://www.amxmodx.org/forums/viewtopic.php?p=59903


FORUM MOD
=========
Add interactivity between your web forum and your AMX Mod X server.

Currently phpBB and PHPNuke supported, IPB will come (back) shortly. You can easily write FMAPI addons for other forums/communities.

You can choose to only have users registered on your forum access your server - and optionally choose to only let them use their names from the forum.

In your forum you can set what stats like rank, accuracy and efficiency will be displayed below a member's avatar in posts.

You can also choose to have anyone access the server, but prepend (and/or append) nonregistered users' names with a prefix (default Pub:), or postfix (default empty).

You can specify what extra access flags (reserved slots... ) registered users will have over nonregistered users.

Includes a simple (optional) PM reading client. Only dead/spectators in Cstrike can read mail.

For installation, CAREFULLY read the instructions provided in the comment section of the plugin source. It's at the top of the file.
Also you must read the installation instructions for your web forum/community software which are in the file implementing the FMAPI addon for your software.

NEW in 0.5: You can now assign admins to your game server simply by adding a forum user to a forum group! Here's how to set it up:
Create a group in your forum like "Game server admin" (or whatever name), and then register it in server console using 'amx_registergroup "Game server admin" "bcdefghijk"' to automagically
add extra admin powers to any forum user being a member of that group. You can create several of these groups, just be sure to register them using the amx_registergroup command.

And more...



INSTALLATION
============
Forum:
Do appropriate modification of your forum/community. Info about this is in the forummod_fmapi_*.inc files.
Example: For phpbb, you open forummod_fmapi_phpbb.inc and read the instructions.

{
	This part will be moved to the IPB file as soon as that has been created. Disregard it for now because it is of no use to anyone... except maybe people wanting to add support
	for IPB ahead of me. ;-)

	For IPB forums, you're in luck. IPB has this really handy feature called "Custom Profile Fields". Just go to admin CP->Users and Groups->Custom Profile Fields and add a new field
	titled "STEAMID" (be sure not to misspell here, although case is insensitive). Preferrably you would want to allow people to fill it in when they register, and allow/disallow people from
	seeing this setting in other users' profiles. All of these settings are at your choice of course although you likely should make sure the user can edit this field in his properties at any time.
	You absolutely must do this before you start the server with this plugin loaded, or the plugin will pause itself because it cannot find the STEAMID profile setting.
}

Plugin:
1) First of all, make sure you have your forum/community up, modded and running.

2) Your configs/sql.cfg must be properly configured with correct settings. Add these cvars:

fm_forum_host	// This should be the ip/host of the computer hosting the forum's SQL database.
fm_forum_user	// The SQL user's username.
fm_forum_pass	// The SQL user's password.
fm_forum_db		// The name of the forum's database at the SQL host. Default is "phpbb" because this is the default name with phpBB forums. Default name for IPB forums is "ipb".

EXAMPLE: If your forum SQL database exists on the same computer as your game server, your sql.cfg might look something like this:
fm_forum_host	"127.0.0.1"				// NOTE: On some (?) Linux systems, specifying "localhost" instead of "127.0.0.1" is a bad idea! Always use "127.0.0.1" on Linux.
fm_forum_user	"amxuseraccess" 		// You must change this to the name of the SQL user having access to the forum's sql database.
fm_forum_pass	"verysecretpassword"	// You must change this to the password of the SQL user having access to the forum's sql database.
fm_forum_db		"phpbb"					// Make sure this is right as well. It is the name of the database holding all of the forum's data tables.

Of course you can define these cvars in another place than sql.cfg (amxx.cfg, server.cfg etc are fine too), but keeping the sql configs at one place helps keep things a tad tidier.
If all of these are setup the right way you will get this message in server console when plugin kicks: "[Forum Mod] Connected successfully to SQL db.".

3) Then make sure you set up the cvars listed under usage below to your needs.

4) Find the line "Adjust below settings to your liking". Do what it tells you.

5) Before you compile this plugin, find the forummod_fmapi_*.inc file corresponding to your forum. Rename it to forummod_fmapi.inc. Then compile.

6) Install plugin as usual. Place the amxx file into amxmodx/plugins, and add a line to amxmodx/configs/plugins.ini saying: forummod.amxx, if that is your filename.

7) Note that in plugins.ini you should put this plugin BELOW admin.amxx, but above any plugin (default is adminslots.amxx) dealing with registered slots, if you plan on having this plugin give that privilege to people.

8) You must have modules engine and fakemeta up and running on your server. Check amxmodx/configs/modules.ini. Possibly other modules are needed as well depending on your setup of this file.

- Done.


USAGE
=====
cvar: fm_forum_host		(Described above)
cvar: fm_forum_user		(Described above)
cvar: fm_forum_pass		(Described above)
cvar: fm_forum_db		(Described above)
cvar: fm_kicknonregged	(Default 0. Set it to 1 to disallow nonregged people from entering server.)
cvar: fm_regurl			(Default empty. Set this to the URL of your register page. It will be displayed when a player gets booted for not being registered. If empty, the URL will not be displayed when a user is kicked.)
cvar: fm_prepend		(Default "Pub:". When fm_kicknonregged is set to 0, nonregistered players will have their names prepended with this tag. You can set this to empty ("") and no prefix will be used.)
cvar: fm_append			(Default empty. Used exactly like above, only it adds the specified text *after* player's name. Prepend+append can be used individually, simultaneously, or none at all.)
cvar: fm_forceforumname	(Default 1. When set to 0, registered users may choose any name they like. At 1 they are forced to have their name from forum.)
cvar: fm_access			(Default "bm" ("b" is access to reserved slots, and "m" means they are registered - don't remove it!). Specify here what additional access flags a registered user should have. Look in users.ini for the flag list.)
cvar: fm_forumurl		(Default "" (empty).  Set this to the URL of your forum.)
cvar: fm_stats			(Default "cdgiklmn". Which means the following stats are exported to forum: deaths, frags, hs, defused, plants, explosions, rank, efficiency, accuracy.)

client command: amx_readmail (Registered users only. Will open their PM inbox, so they can read their forum PMs.)
server command: amx_registergroup <group name> <access flags> (Register a group by name. The name MUST exist as a group in your forum or this command will not work. As 2nd parameter, add the extra flags (bcdf...) that you want members of this group to have over nonmembers.
client/server command: amx_listgroups (Just a simple command to make sure that the groups were registered as intended.)


VERSIONS
========
Released	Version		Comment
050527		0.7.2		Minor fix to correctly show the complete pub-ized form of new name when unregistered players change name.
						Groups didn't work anymore. Should be fixed.
050430		0.7.1		No real changes in this plugin. However a new FMAPI addon was created for PHPNuke. Also the FMAPI addon for phpbb is updated because of problems with the mail client.
050429		0.7 beta	No real changes in features. However large parts are rewritten, structure is changed, so that it should be "easy" to write addons
						to support more forums. Right now the only addon created is the one for phpBB. To write new addons you should modify the file forummod_fmapi.inc. It currently has
						two functions which you must define yourself. The bundled one is for phpbb forums. Sorry, I haven't written this for IPB or any other forum yet. You can do it
						yourself now though to avoid waiting. ;-) Note that stats exporting to forums still probably is written for phpbb exclusively, but you could possibly modify
						your forum user table to work with that, if you know how. This means that there likely aren't any changes needed be made for the stats part of this plugin to work
						with your forum, it's just your forum that needs the right modding.
						Consolidated all fm_stats* cvars to one cvar called fm_stats. It uses letter flags. Example: "ab" means show tks and damage.
050325		0.6.3b		Should now compile normally even if you comment it ALLOWREADINGMAIL.
050115		0.6.3		Problem with NS and registry of groups should be solved.
050115		0.6.2		Various small fixes and touchups, mainly to the stats exporting part.
050114		0.6.1		When the csstats are reset (by setting the cvar "csstats_reset" to 1, then restarting map), the stats in forum database are now also reset.
050113		0.6			New feature: export player stats to forum, only phpBB supported for now. "Steamid Mod.txt" for phpBB updated.
050112		0.5.3		Added the cvars fm_forum_host, fm_forum_user, fm_forum_pass. These are now used to connect to forum's database. Update your settings! (sql.cfg)
						Updated descriptions.
						Fixed SQL error reporting.
050110		0.5.2		A bug with groups likely made everyone a member of every group. :-]
050108		0.5.1		No new features, just rewrote some of the installation description.
041229		0.5			Added groups.
041228		0.4.1		Updated to use IPB's "Custom Profile Field" feature. Just add a field named "STEAMID" (case insensitive)! No need to hack your forum! :-)
041227		0.4			Added support for IPB.
						While reading mail you would sometimes buy weapons etc when pressing the mail menu buttons. Should be fixed. :-)
041217		0.3			If kicking unregistered player, don't force pubname.
						"fm_forceforumname 0" still forced forum names on ppl.
040921		0.2.2		More updates on names. Shouldn't now be able to use any other name if you login with a regged Steam ID. (If you can, tell me!)
040918		0.2.1		Continued work on names. Added fm_append, which works like fm_prepend only it adds the text after names.
040916		0.2			Reworked name changing system. Now needs engine+fakemeta modules also.
040916		0.1			First release - hello world! :-)


TO DO / WISH LIST
=================
- bbcode in pm client, possibly update newprivmsgs etc
- mysql reading only when plugin loads to minimize sql traffic? (might have to load a lot of steamids into some local place) (this is low prio and/or a bad design choice, will likely not do this)
- right time depending on timezone setting in bbs (started on this, have a lot to do still)
- support for relative/prio registration access levels
knocker:
advantages for registered users:

disadvantages for unregistered guests:
- they get gagged (or they get 5 "free" chatmessages with warning to register) - i like this cuz i think mostly non-forum users flame around
- glow red - some players like to camp

general:
- everything above is optional  so every admin can chose his own settings.

	  - Johnny got his gun
*/

#include <amxmodx>
#include <amxmisc>
#include <dbi>
#include <engine>
#include <fakemeta>
#include <fakemeta_stocks>

// ---------- Adjust below settings to your liking ---------------------------------------
// ---------- Remove the two slashes at the beginning of a line to uncomment (=make visible) that line. Add two slashes to comment (=remove) that line.
#define FMACCESS				ADMIN_LEVEL_A	// If you need to use another flag defining a user as "registered in forum", replace ADMIN_LEVEL_A (flag "m") with another one from amxconst.h.
												// This flag must also be set in fm_access cvar. A user MUST NOT have this access defined in users.ini!

#define ALLOWREADINGMAIL						// Comment if you completely want to remove the PM reading client. phpBB + IPB supported currently.

//#define CS_STATS_EXPORT_TO_FORUM				// ONLY phpBB and Counter-strike supported currently. If you are using any other unsupported forum, comment this out.
// ---------- Adjust above settings to your liking ---------------------------------------

#if defined CS_STATS_EXPORT_TO_FORUM
// These are the flags used with the cvar fm_stats:
#define DISPLAY_TKS				0 // a
#define DISPLAY_DAMAGE			1 // b
#define DISPLAY_DEATHS			2 // c
#define DISPLAY_FRAGS			3 // d
#define DISPLAY_SHOTS			4 // e
#define DISPLAY_HITS			5 // f
#define DISPLAY_HS				6 // g
#define DISPLAY_DEFUSIONS		7 // h
#define DISPLAY_DEFUSED			8 // i
#define DISPLAY_PLANTS			9 // j
#define DISPLAY_EXPLOSIONS		10 // k
#define DISPLAY_RANK			11 // l
#define DISPLAY_EFFICIENCY		12 // m
#define DISPLAY_ACCURACY		13 // n

#include <csstats>
#include <csx>
#endif // CS_STATS_EXPORT_TO_FORUM



// User stats parms id
#define STATS_KILLS             0
#define STATS_DEATHS            1
#define STATS_HS                2
#define STATS_TKS               3
#define STATS_SHOTS             4
#define STATS_HITS              5
#define STATS_DAMAGE            6
#define STATS_RANK				7
#define BOMBSTATS_DEFUSIONS		0 // - total defusions
#define BOMBSTATS_DEFUSED		1 // - bomb defused
#define BOMBSTATS_PLANTS		2 // - bomb plants
#define BOMBSTATS_EXPLOSIONS	3 // - bomb explosions

#define MENUBUTTON1				(1<<0)
#define MENUBUTTON2				(1<<1)
#define MENUBUTTON3				(1<<2)
#define MENUBUTTON4				(1<<3)
#define MENUBUTTON5				(1<<4)
#define MENUBUTTON6				(1<<5)
#define MENUBUTTON7				(1<<6)
#define MENUBUTTON8				(1<<7)
#define MENUBUTTON9				(1<<8)
#define MENUBUTTON0				(1<<9)
#define MENUSELECT1				0
#define MENUSELECT2				1
#define MENUSELECT3				2
#define MENUSELECT4				3
#define MENUSELECT5				4
#define MENUSELECT6				5
#define MENUSELECT7				6
#define MENUSELECT8				7
#define MENUSELECT9				8
#define MENUSELECT0				9
#define QUERYSIZE				2047
#define MAILLENGTH				2047

#define MAXGROUPS				8

#define CVAR_HOST			"fm_forum_host"
#define CVAR_USER			"fm_forum_user"
#define CVAR_PASS			"fm_forum_pass"
#define CVAR_DB				"fm_forum_db"
#define CVAR_KICKNONREGGED	"fm_kicknonregged"
#define CVAR_REGURL			"fm_regurl"
#define CVAR_APPEND			"fm_append"
#define CVAR_PREPEND		"fm_prepend"
#define CVAR_REGACCESS		"fm_access"
#define CVAR_FORCEFORUMNAME	"fm_forceforumname"
#define CVAR_FORUMURL		"fm_forumurl"
#define CVAR_TIMEZONE		"fm_timezone"

#define CVAR_STATS			"fm_stats"

#include "forummod_db"
#include "forummod_fmapi_phpnuke"

// Global vars below
new g_regged
new bool:g_editsaytext[33]
new bool:g_initialized = false
new g_authorized
new g_names[33][32]
new g_forumids[33]
new g_groupflags[33]

new g_groupsCount = 0
new g_groupsTitles[MAXGROUPS][MAXGROUPNAMESIZE + 1]
new g_groupsAccess[MAXGROUPS]
new g_groupsIds[MAXGROUPS]

// Global vars above

public plugin_modules() {
	require_module("dbi")
	require_module("engine")
	require_module("fakemeta")

	#if defined CS_STATS_EXPORT_TO_FORUM
	require_module("csx")
	require_module("csstats")
	#endif // CS_STATS_EXPORT_TO_FORUM
}

public plugin_precache() {
	register_forward(FM_SetClientKeyValue, "forward_SetClientKeyValue")
}

bool:regged(id) {
	return (g_regged & (1<<id-1)) ? true : false
}
setregged(id, bool:state) {
	if (state)
		g_regged |= (1<<(id-1))
	else
		g_regged &= ~(1<<(id-1))
}
bool:authorized(id) {
	return (g_authorized & (1<<id-1)) ? true : false
}
setauthorized(id, bool:state) {
	if (state)
		g_authorized |= (1<<(id-1))
	else
		g_authorized &= ~(1<<(id-1))
}

public client_authorized(id) {
	if (is_user_bot(id))
		return PLUGIN_CONTINUE

	setauthorized(id, true)
	const LEN = 32
	new authid[LEN + 1], oldname[32], newname[32]

	get_user_authid(id, authid, LEN)
	get_user_name(id, oldname, 31)

	g_groupflags[id] = 0
	setregged(id, initialcheckreg2(id, authid, newname))
	if (regged(id)) {
		if (equal(oldname, newname))
		server_print("[%s] %s from forum logs on. (%s)", PLUGINNAME, newname, authid)
		else {
			server_print("[%s] %s is registered as %s in forums. (%s)", PLUGINNAME, oldname, newname, authid)

			//new infokeybuffer[1024]
			//get_info_keybuffer(id, infokeybuffer, 1023)

			if (get_cvar_num(CVAR_FORCEFORUMNAME))
				force_forumname(id, oldname, authid)
		}
	}
	else {
		server_print("[%s] %s is not registered. (%s)", PLUGINNAME, oldname, authid)
		if (get_cvar_num(CVAR_KICKNONREGGED)) {
			new regurl[128]
			get_cvar_string(CVAR_REGURL, regurl, 127)
			if (strlen(regurl) > 0)
				server_cmd("kick #%d Register your Steam ID %s at %s to access this server.", get_user_userid(id), authid, regurl)
			else
				server_cmd("kick #%d This server only accepts registered Steam IDs.", get_user_userid(id))

			return PLUGIN_CONTINUE
		}

		force_pubname(id, oldname, 31, authid)
	}

	return PLUGIN_CONTINUE
}


public bool:initialcheckreg2(id, authid[], name[]) {
	if (is_user_bot(id) || equal(authid, "BOT"))
		return false

	// Start by removing the registered access flag!
	removeregisteredaccess(id)

	new groups[MAXGROUPS] = {-1, ...}
	if (!FMAPI_GetReggedInformation(authid, (g_groupsCount < 1 ? false : true), g_forumids[id], g_names[id], groups, MAXGROUPS))
		return false

	// From here this person is regged. Add flags.
	addregisteredaccess(id)

	// Copy new name into name string
	copy(name, 31, g_names[id])

	// Say goodbye if no groups are registered.
	g_groupflags[id] = 0
	if (g_groupsCount == 0) {
		return true
	}

	// Format the groups to comma separated string/list...
	new szGroups[128] = ",", len = 1
	for (new i = 0; i < MAXGROUPS && groups[i] != -1; i++) {
		len += format(szGroups[len], 127 - len, "%d,", groups[i])
	}

	// Find groups with a name that is registered, and match these against a group id and match that to the group ids this user has
	//server_print("This user is member of these groups: ^"%s^"", groups)
	new numstr[10]
	server_print("[%s] %s's groups: %s", PLUGINNAME, g_names[id], szGroups)
	for (new i = 0; i < g_groupsCount; i++) {
		// Does this user g_forumids[id] have this group id g_groupsIds[i], then add flags g_groupsAccess[i]
		format(numstr, 9, ",%d,", g_groupsIds[i])
		if (contain(szGroups, numstr) != -1) {
			// Yes a member
			new flagsstr[64]
			get_flags(g_groupsAccess[i], flagsstr, 63)
			server_print("[%s] %s is a member of the group ^"%s^". Adding these flags: ^"%s^"", PLUGINNAME, name, g_groupsTitles[i], flagsstr)
			// Add flags
			g_groupflags[id] |= g_groupsAccess[i]
		}
		else {
			// Not a member
			server_print("[%s] %s: NOT A MEMBER", PLUGINNAME, g_groupsTitles[i])
		}
	}
	AddGroupFlags(id)

	// This player is regged.
	return true
}

// Some info about player flags:
// Flags are empty when player logs on. At the first client_authorized,
// amxmodx sets the flags from users.ini.
// Also the flags are reset at each client_infochanged (called when name changes, etc)
// We need to reset regflags after all of these.
// We do it initially in client_authorized -> when this function below is called
// This function is also called from the client console command to recheck regstatus when/if needed.
// This is the sole function that should read data from the forum database - in all other cases
// we rely on the g_regged[] array.
// In client_infochanged we must reset flags and do this based on the array. The array only changes
// as the return value from the below function.

AddGroupFlags(id) {
	new flags = get_user_flags(id)
	flags |= g_groupflags[id]
	set_user_flags(id, flags)
}

removeregisteredaccess(id) {
	set_user_flags(id, get_user_flags(id) & ~FMACCESS)
}

addregisteredaccess(id) {
	new flags = get_user_flags(id)

	new sz_regaccessflags[64], regaccessflags
	get_cvar_string(CVAR_REGACCESS, sz_regaccessflags, 63)
	regaccessflags = read_flags(sz_regaccessflags)

	/*
	new sflags[32]
	get_flags(flags, sflags, 31)
	server_print("%d's flags before: %s", id, sflags)
	*/

	flags |= regaccessflags

	//server_print("[%s] Adding reserved slot flag to %s.", PLUGINNAME, g_reggednames[id])
	set_user_flags(id, flags)

	/*
	flags = get_user_flags(id)

	get_flags(flags, sflags, 31)
	server_print("%d's flags after having added regged flags: %s regged() returns: %d", id, sflags, regged(id))
	*/
}

public forward_SetClientKeyValue(id, buffer[], key[], value[]) {
	if ((!is_user_connecting(id) && !is_user_connected(id)) || !authorized(id) || is_user_bot(id) || !equal(key, "name"))
		return PLUGIN_CONTINUE
	//server_print("%d's buffer:^n%s^n^nkey: %s^nvalue: %s", id, buffer, key, value)

	//server_print("ID: %d^nBUFFER: ^"%s^"^nKEY: ^"%s^"^nVALUE: %s", id, buffer, key, value)

	new newname[33]
	copy(newname, 32, value)
	new authid[64]
	get_user_authid(id, authid, 63)

	if (regged(id)) {
		if (get_cvar_num(CVAR_FORCEFORUMNAME)) {
			if (force_forumname(id, newname, authid) == FMRES_SUPERCEDE) {
				// Call this function with new name
				EF_SetClientKeyValue(id, key, g_names[id]) // setclientkeyvalue(id, buffer, key, g_names[id])
				// And supercede the forwarded function
				return FMRES_SUPERCEDE
			}
		}
	}
	else {
		if (force_pubname(id, newname, 32, authid) == FMRES_SUPERCEDE) {
			// Call this function with new name
			EF_SetClientKeyValue(id, key, newname) // setclientkeyvalue(id, buffer, key, newname)
			// And supercede the forwarded function
			return FMRES_SUPERCEDE
		}
		//g_editsaytext[id] = true
	}
	return FMRES_IGNORED
}


stock setclientkeyvalue(id, buffer[], key[], value[]) {
	//EngFunc_SetClientKeyValue	 // void )		(int clientIndex, char *infobuffer, char *key, char *value);
	engfunc(EngFunc_SetClientKeyValue, id, buffer, key, value)
}

public client_infochanged(id) {
	//if (regged(id))
		//addregisteredaccess(id)

	// don't care for not authorized players, bots, or if they are connecting (which should be same as not authorized yet)
	if (!authorized(id) || is_user_bot(id) || is_user_connecting(id))
		return PLUGIN_CONTINUE
	//g_authorized |= (1<<(id-1)) !g_authorized[id] ||
	/*
	new buffer[128]
	get_info_keybuffer(id, buffer, 127)
	client_print(0, print_chat, "ic %d:%s", id, buffer)
	server_print("ic %d:%s", id, buffer)
	*/

	// Had to add this block because the admin.sma plugin removes user's flags upon infochanged, then rereads them from source, thus removing our access :-/
	// Block start
	const LEN = 32
	new authid[LEN + 1], name[32]

	get_user_authid(id, authid, LEN)
	get_user_name(id, name, 31)

	// Flags are reset from users.ini, remove all registered flags from this player
	removeregisteredaccess(id)

	//if (checkreg(id, authid, name)) {
	if (regged(id)) {
		// This player is regged. Add flags.
		addregisteredaccess(id)
		if (g_groupsCount > 0)
			AddGroupFlags(id)
		//server_print("[%s] %s (%s) is registered.", PLUGINNAME, name, authid)

		// dont set name here, we need to do the code below properly
		// (or the person won't be told he can't use a name if he changed and is forum-regged)
	}
	// Block end

	//const NEWNAMESIZE = 31
	//new newname[NEWNAMESIZE + 1] // oldname[32],
	//get_user_name(id, oldname, 31)
	//get_user_info(id, "name", newname, 31)

	//server_print("infochanged name: %s, newname: %s", name, newname)
	//client_print(id, print_chat, "infochanged name: %s, newname: %s", name, newname)


	//if (!g_regged[id]) {
		// Force prefix on nonregistered players
		//return force_pubname(id, newname, NEWNAMESIZE, authid)

	//}
	//else {
		// Regged here
		//return force_forumname(id, newname, authid)
	//}

	//new idd[1]
	//idd[0] = id
	//set_task(0.1, "checkname", 0, idd, 1)

	return PLUGIN_CONTINUE
}

// format "*PUB" =
// "nisse" + "PUB"
// "nissePUB"
force_pubname(id, newname[], const NEWNAMESIZE, const AUTHID[]) {
	new prepend[32], append[32]
	get_cvar_string(CVAR_PREPEND, prepend, 31)
	get_cvar_string(CVAR_APPEND, append, 31)
	new const PREPENDLENGTH = strlen(prepend)
	new const APPENDLENGTH = strlen(append)
	new bool:do_prepend = true, bool:do_append = true
	// Don't bother doing this if prepend cvar is empty!
	if (PREPENDLENGTH == 0)
		do_prepend = false
	if (APPENDLENGTH == 0)
		do_append = false

	if (!do_prepend && !do_append)
		return FMRES_IGNORED

	// If name already starts with these chars, return here.
	if (do_prepend && !equal(prepend, newname, PREPENDLENGTH))
		format(newname, NEWNAMESIZE, "%s%s", prepend, newname)

	new newnamestartappendpos = strlen(newname) - PREPENDLENGTH
	if (do_append && (newnamestartappendpos < 0 || !equal(append, newname[newnamestartappendpos], PREPENDLENGTH)))
		format(newname, NEWNAMESIZE, "%s%s", newname, append)

	server_print("[%s] Forcing pub name form on %s's name because person is not registered at forums. (%s)", PLUGINNAME, newname, AUTHID)
	new regurl[128]
	get_cvar_string(CVAR_REGURL, regurl, 127)
	if (strlen(regurl) > 0)
		console_print(id, "Because you aren't registered at forums at %s you must use the form ^"%s^".", regurl, newname)
	else
		console_print(id, "Because you aren't registered at forums you must use the form ^"%s^".", newname)

	set_user_info(id, "name", newname) // Force pub name here

	//	This message is sent after this, the fourth string parameter will be off, it lacks the "Pub:" thingy:
	//
	//	L 09/17/2004 - 13:00:23: [JGHG Trace] {MessageBegin type=SayText(76), dest=MSG_B
	//	ROADCAST(0), classname=nil netname=nil
	//	L 09/17/2004 - 13:00:23: [JGHG Trace] WriteByte byte=1
	//	L 09/17/2004 - 13:00:23: [JGHG Trace] WriteString string=#Cstrike_Name_Change
	//	L 09/17/2004 - 13:00:23: [JGHG Trace] WriteString string=Pub:tjoho
	//	L 09/17/2004 - 13:00:23: [JGHG Trace] WriteString string=trevligt
	//	L 09/17/2004 - 13:00:23: [JGHG Trace] MessageEnd}
	g_editsaytext[id] = true
	copy(g_names[id], 31, newname)

	return FMRES_SUPERCEDE
}

public message_saytext() {
	//log_amx("message_saytext start, args: %d, argtype1: %d, id: %d, edit?: %s, argtype4: %d, argtype2: %d", get_msg_args(), get_msg_argtype(1), get_msg_arg_int(1), g_editsaytext[get_msg_arg_int(1)] ? "yes" : "no", get_msg_argtype(4), get_msg_argtype(2))
	//client_print(0, print_chat, "message_saytext start, args: %d, argtype1: %d, id: %d, edit?: %s, argtype4: %d, argtype2: %d", get_msg_args(), get_msg_argtype(1), get_msg_arg_int(1), g_editsaytext[get_msg_arg_int(1)] ? "yes" : "no", get_msg_argtype(4), get_msg_argtype(2))

	// Wrong number of expected args?
	// First arg where player index is stored not of expected type BYTE?
	if (get_msg_args() != 4 || get_msg_argtype(1) != ARG_BYTE)
		return PLUGIN_CONTINUE

	// Not set to edit the say text?
	// 2nd parameter must be string
	new id = get_msg_arg_int(1)
	if (!g_editsaytext[id] || get_msg_argtype(2) != ARG_STRING)
		return PLUGIN_CONTINUE

	new msgtype[32]
	get_msg_arg_string(2, msgtype, 31)

	// 2nd parameter must be this string...
	if (!equal(msgtype, "#Cstrike_Name_Change"))
		return PLUGIN_CONTINUE

	// Fourth arg where new name string is expected to be stored as STRING not of right type?
	if (get_msg_argtype(4) != ARG_STRING)
		return PLUGIN_CONTINUE

	g_editsaytext[id] = false // Consider saytext edited from here

	//new name[33]
	//get_msg_arg_string(4, name, 32)
	//server_print("Fourth arg sent is %s for %d, setting arg to %s", name, id, g_names[id])
	//client_print(0, print_chat, "Fourth arg sent is %s for %d, setting arg to %s", name, id, g_names[id])

	set_msg_arg_string(4, g_names[id])

	return PLUGIN_CONTINUE
}

force_forumname(id, const OLDNAME[], const AUTHID[]) {
	// Return and continue if name already is forum name.
	if (equal(OLDNAME, g_names[id]))
		return FMRES_IGNORED

	server_print("[%s] Forcing forum name %s on %s (%s)", PLUGINNAME, g_names[id], OLDNAME, AUTHID)
	console_print(id, "Sorry, you must use your name %s from forums.", g_names[id], OLDNAME)

	if (strlen(g_names[id]) == 0) {
		log_amx("[%s] ERROR - length of forum name is 0, won't set it on %s!", PLUGINNAME, OLDNAME)
		return FMRES_IGNORED
	}

	set_user_info(id, "name", g_names[id]) // Force forum name
	set_msg_block(get_user_msgid("SayText"), BLOCK_ONCE)

	return FMRES_SUPERCEDE
}

stock localtrim(stringtotrim[], const LEN, charstotrim, const bool:FROMLEFT = true) {
	if (charstotrim <= 0)
		return

	if (FROMLEFT) {
		new maxlen = strlen(stringtotrim)
		if (charstotrim > maxlen)
			charstotrim = maxlen

		format(stringtotrim, LEN, "%s", stringtotrim[charstotrim])
	}
	else {
		new maxlen = strlen(stringtotrim) - charstotrim
		if (maxlen < 0)
			maxlen = 0

		format(stringtotrim, maxlen, "%s", stringtotrim)
	}
}



/*
createtable() {
	new query[1024] = "CREATE TABLE IF NOT EXISTS `%s` (`steamid` varchar(30) NOT NULL default '', `regtime` int(11) NOT NULL default '0', `lastactivity` int(11) default '0', `lastusedname` varchar(33) NOT NULL default '', PRIMARY KEY  (`steamid`)) TYPE=MyISAM;"
	format(query, 1023, query, G_USERSTABLE)

	mysql_query(g_sql, query)
	dbi_check_error()
}
*/

/*
public death_event() {
	new id = read_data(2)
	if (!regged(id))
		return PLUGIN_CONTINUE

	const LEN = 32
	new authid[LEN + 1]
	get_user_authid(id, authid, LEN)

	handlemessages(id, authid)

	return PLUGIN_CONTINUE
}
*/
#if defined ALLOWREADINGMAIL
/*
stock handlemessages(id, authid[]) {
	new newmessages = getnrofnewmessages(authid)

	if (newmessages == 0) {
		client_print(id, print_chat, "No new messages to you in forum...")
		return
	}

	new menuBody[512], flags = MENUBUTTON1|MENUBUTTON2

	format(menuBody, 511, "You have %d unread messages in your inbox.^n1. Get subjects^n2. Close", newmessages)

	show_menu(id, flags, menuBody)
}
*/

// Wow, this is old... update to use dbi interface!
/*
stock getnrofnewmessages(authid[]) {
	const LONGER = 256
	new query[LONGER + 1]

	format(query, LONGER, "SELECT `%s` FROM %s WHERE `%s` = ^"%s^" && `%s` > 0", g_FIELDS_NEWPRIVMSG, g_TABLE_USERS, g_FIELD_USERS_STEAMID, authid, g_FIELDS_NEWPRIVMSG)
	if (!connect()) {
		log_amx("[%s] Failed connecting to database while reading messages! (getnrofnewmessages)", PLUGINNAME)
		return 0
	}
	mysql_query(g_sql, query)

	if (dbi_check_error()) {
		closedbi()
		return 0
	}

	if (!mysql_nextrow(g_sql)) {
		//client_print(id, print_chat, "No new messages to you in forum...")
		closedbi()
		return 0
	}
	new sz_messagesinforum[64], messagesinforum
	mysql_getfield(g_sql, 1, sz_messagesinforum, 63)
	closedbi()
	messagesinforum = str_to_num(sz_messagesinforum)

	//client_print(id, print_chat, "You have %d new message%s in forum!", messagesinforum, messagesinforum > 1 ? "s" : "")

	return messagesinforum
}
*/

public messages_fn(id, key) {
	switch (key) {
		case MENUSELECT1: {
			/*
			new forumurl[128]
			get_cvar_string(CVAR_FORUMURL, forumurl, 127)
			surf(id, forumurl)
			*/
			g_mailpage[id] = 1
			getmailsubjectsmenu2(id)
		}
		case MENUSELECT2: {
			// nothing
		}
	}

	return PLUGIN_HANDLED
}

public subjects_fn(id, key) {
	switch (key) {
		case MENUSELECT9: {
			g_mailpage[id]++
			getmailsubjectsmenu2(id)
		}
		case MENUSELECT0: {
			g_mailpage[id]--
			getmailsubjectsmenu2(id)
		}
		default: {
			// Read mail based on key + page
			if (g_msgids[id][key]) // Msg can be invalid if on a page with less than 8 mails.
				readmail(id, key)
			getmailsubjectsmenu2(id)
		}
	}
	return PLUGIN_HANDLED
}

readmail(id, msg) {
	new message[MAILLENGTH]
	new subject[64]
	getmsg2(g_msgids[id][msg], message, MAILLENGTH - 1)
	getsubject2(g_msgids[id][msg], subject, 63)

	show_motd(id, message, subject)
}

getmsg2(const MSGID, message[], const LENGTH) {
	const LONGER = 1023
	new query[LONGER + 1]
	format(query, LONGER, "\
	SELECT `%s` \
	FROM %s \
	WHERE `%s` = ^"%d^" \
	LIMIT 1", g_FIELD_MSGS_TEXT_TEXT, g_TABLE_MSGS_TEXT, g_FIELD_MSGS_TEXT_ID, MSGID)

	const FIELD_MSGTEXT = 1

	new Sql:sql
	if (!fm_db_connect(sql)) {
		log_amx("Failed connecting to database when trying to read messages! (getmsg2)")
		return
	}

	new Result:result = dbi_query(sql, query)

	if (result < RESULT_NONE) {
		new sqlerror[256]
		dbi_error(sql, sqlerror, 255)
		log_amx("Error during getmsg2(): %s", sqlerror)
		dbi_close(sql)
		return
	}
	else if (result == RESULT_NONE) {
		dbi_close(sql)
		server_print("getmsg2() fails because result == RESULT_NONE")
		return
	}
	else if (!dbi_nextrow(result)) {
		format(message, LENGTH, "Message could not be found in database.")
		dbi_free_result(result)
		dbi_close(sql)
		return
	}

	// Get text
	dbi_field(result, FIELD_MSGTEXT, message, LENGTH)
	dbi_free_result(result)

	dbi_close(sql)
}
/*
getmsg(msgid, message[], const LENGTH) {
	const LONGER = 1023
	new query[LONGER + 1]
	format(query, LONGER, "\
	SELECT `%s` \
	FROM %s \
	WHERE `%s` = ^"%d^" \
	LIMIT 1", g_FIELD_MSGS_TEXT_TEXT, g_TABLE_MSGS_TEXT, g_FIELD_MSGS_TEXT_ID, msgid)

	const FIELD_MSGTEXT = 1

	if (!connect()) {
		log_amx("[%s] Failed connecting to database when trying to read messages! (getmsg)", PLUGINNAME)
		return
	}

	new Result:result = dbi_query(g_sql, query)
	//log_amx("[%s] DEBUG getmailsubjectsmenu 2", PLUGINNAME)
	if (dbi_check_error()) {
		format(message, LENGTH, "Error retrieving message from database.")
		closedbi()
		return
	}
	else if (!dbi_nextrow(result)) {
		format(message, LENGTH, "Message could not be found in database.")
		dbi_free_result(result)
		closedbi()
		return
	}

	// Get text
	dbi_field(result, FIELD_MSGTEXT, message, LENGTH)
	dbi_free_result(result)

	closedbi()
}
*/
getsubject2(const MSGID, subject[], const LENGTH) {
	const LONGER = 1023
	new query[LONGER + 1]
	format(query, LONGER, "\
	SELECT `%s` \
	FROM %s \
	WHERE `%s` = ^"%d^" \
	LIMIT 1", g_FIELD_MSGS_SUBJECT_SUBJ, g_TABLE_MSGS_SUBJ, g_FIELD_MSGS_SUBJECT_ID, MSGID)

	const THE_FIELD_SUBJECT = 1

	new Sql:sql
	if (!fm_db_connect(sql)) {
		log_amx("Failed connecting to database when trying to read messages! (getsubject)")
		return
	}

	new Result:result = dbi_query(sql, query)

	if (result < RESULT_NONE) {
		new sqlerror[256]
		dbi_error(sql, sqlerror, 255)
		log_amx("Error retrieving subject from database: %s", sqlerror)
		dbi_close(sql)
		return
	}
	else if (result == RESULT_NONE) {
		dbi_close(sql)
		server_print("getmsg2() fails because result == RESULT_NONE")
		return
	}
	else if (!dbi_nextrow(result)) {
		format(subject, LENGTH, "Subject not found.")
		dbi_free_result(result)
		dbi_close(sql)
		return
	}

	// Get subject
	dbi_field(result, THE_FIELD_SUBJECT, subject, LENGTH)

	dbi_free_result(result)
	dbi_close(sql)
}
/*
getsubject(msgid, subject[], const LENGTH) {
	const LONGER = 1023
	new query[LONGER + 1]
	format(query, LONGER, "\
	SELECT `%s` \
	FROM %s \
	WHERE `%s` = ^"%d^" \
	LIMIT 1", g_FIELD_MSGS_SUBJECT_SUBJ, g_TABLE_MSGS_SUBJ, g_FIELD_MSGS_SUBJECT_ID, msgid)

	const THE_FIELD_SUBJECT = 1

	if (!connect()) {
		log_amx("[%s] Failed connecting to database when trying to read messages! (getsubject)", PLUGINNAME)
		return
	}

	new Result:result = dbi_query(g_sql, query)
	//log_amx("[%s] DEBUG getmailsubjectsmenu 2", PLUGINNAME)
	if (dbi_check_error()) {
		format(subject, LENGTH, "Error retrieving subject from database.")
		closedbi()
		return
	}
	else if (!dbi_nextrow(result)) {
		format(subject, LENGTH, "Subject not found.")
		dbi_free_result(result)
		closedbi()
		return
	}

	// Get subject
	dbi_field(result, THE_FIELD_SUBJECT, subject, LENGTH)
	dbi_free_result(result)

	closedbi()
}
*/

/*
stock resetnewmsgscount(id) {
	// Reset new msgs count
	const LONGER = 256
	new query[LONGER + 1], authid[64]
	get_user_authid(id, authid, 63)
	format(query, LONGER, "UPDATE %s SET `%s` = ^"0^" WHERE `%s` = ^"%s^" && `%s` > 0", G_USERSTABLE, G_FIELDS_NEWPRIVMSG, g_FIELD_USERS_STEAMID, authid, G_FIELDS_NEWPRIVMSG)
	mysql_query(g_sql, query)
	dbi_check_error()
}
*/

getmailsubjectsmenu2(id) {
	if (g_mailpage[id] == 0) // User selected menu "0" - quit menu
		return

	// Reset msg ids
	for (new i = 0; i < SUBJECTS_PER_PAGE; i++)
		g_msgids[id][i] = 0

	const MENUBODYSIZE = 1023
	new menubody[MENUBODYSIZE + 1], flags = 0, rows

	new bool:success = FMAPI_GetMailSubjects(id, g_forumids[id], menubody, MENUBODYSIZE, flags, g_msgids[id], rows)
	if (!success) {
		// This is bad, but doesn't have to be fatal... don't give an error msg, just exit function.
		return
	}

	new menubodylen = strlen(menubody)
	if (rows > 0) {
		// If more rows, insert a "9. More >>>" line...
		if (rows > SUBJECTS_PER_PAGE) {
			menubodylen += format(menubody[menubodylen], MENUBODYSIZE - menubodylen, "\y9\w) Older >>>^n")
			flags |= MENUBUTTON9
		}
	}
	else {
		menubodylen = 0 // Overwrite start by putting this value to 0 - the beginning of the string
		menubodylen += format(menubody[menubodylen], MENUBODYSIZE - menubodylen, "You have no mails^n")
	}

	menubodylen += format(menubody[menubodylen], MENUBODYSIZE - menubodylen, g_mailpage[id] == 1 ? "\y0\w) Exit" : "\y0\w) <<< Newer")
	flags |= MENUBUTTON0

	// Here we should reset user's newmsgscount? Also set unread new messages to unread :-P
	//resetnewmsgscount(id)

	// Show menu
	show_menu(id, flags, menubody, -1, "browsingsubjects")
	//show_menu(index,keys,const menu[], time = -1, title[] = "");)
}

stock surf(id, url[]) {
	if (is_user_alive(id)) {
		client_print(id, print_chat, "Surfing is only for the dead. Amen.")
		return
	}

	if (containi(url, "http://") != 0 && containi(url, "ftp://") != 0) {
		format(url, 127, "http://%s", url)
	}

	new html[128]
	format(html, 127, "<html><head><META HTTP-EQUIV=^"Refresh^" CONTENT=^"0; URL=%s^"></head><body bgcolor=^"black^"><a href=^"%s^">%s</a></body></html>", url, url, url)

	show_motd(id, html, "The forum")

	return
}

public readmail_fn(id, level, cid) {
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED

	if (cstrike_running() && is_user_alive(id)) {
		console_print(id, "Sorry, you can only read mail while you are dead.")
		client_print(id, print_chat, "Sorry, you can only read mail while you are dead.")
		return PLUGIN_HANDLED
	}
	g_mailpage[id] = 1
	getmailsubjectsmenu2(id)

	return PLUGIN_HANDLED
}

public plugin_cfg() {
#if defined AddClientMenuItem
	AddClientMenuItem("Read forum mail", "amx_readmail", FMACCESS, PLUGINNAME)
#else
	AddMenuItem("Read forum mail", "amx_readmail", FMACCESS, PLUGINNAME)
#endif // defined AddClientMenuItem
}
#endif // defined ALLOWREADINGMAIL

/*
public sayMyTime(id, level, cid) {
	// This function is far from finished. I'll look into it later :-)
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED

	if (get_cvar_num("amx_time_voice") ) {
		new mhours[6], mmins[6], whours[32], wmins[32], wpm[6]
		get_time("%H", mhours, 5)
		get_time("%M", mmins, 5)
		new mins = str_to_num(mmins)
		new hrs = str_to_num(mhours) - get_cvar_num(CVAR_TIMEZONE) + getusertimezone(id)
		if (mins)
			num_to_word(mins,wmins,31)
		else
			wmins[0] = 0
		if (hrs < 12)
			wpm = "am "
		else {
			if (hrs > 12)
				hrs -= 12

			wpm = "pm "
		}
		if (hrs)
			num_to_word(hrs, whours, 31)
		else
			whours = "twelve "
		client_cmd(id, "spk ^"fvox/time_is_now %s_period %s%s^"",whours,wmins,wpm )
	}
	new ctime[64]
	get_time("%Y/%m/%d - %H:%M:%S", ctime, 63)
	client_print(id, print_chat, "Your local time:   %s", ctime)

	return PLUGIN_CONTINUE
}
*/

stock getusertimezone(id) {
	new authid[32]
	get_user_authid(id, authid, 31)
	new query[QUERYSIZE + 1]
	format(query, QUERYSIZE, "SELECT `user_timezone` FROM %s WHERE `%s` = ^"%s^"", G_USERSTABLE, g_FIELD_USERS_STEAMID, authid)

	if (!connect()) {
		log_amx("[%s] Failed connecting to database when trying to get time!", PLUGINNAME)
		return 0
	}

	new Result:result = dbi_query(g_sql, query)

	if (dbi_check_error()) {
		closedbi()
		return 0
	}

	if (!dbi_nextrow(result)) {
		log_amx("[%s] Error getting time zone from forum user %s! (No such data existed; set was empty. Returning timezone 0.)", PLUGINNAME, authid)
		dbi_free_result(result)
		closedbi()
		return 0
	}

	// Get timezone
	dbi_field(result, 1, authid, 31) // get into authid because we don't have to allocate another array

	dbi_free_result(result)
	closedbi()

	return str_to_num(authid)
}

public client_disconnect(id) {
	// Should be redundant because this is set when a player is authorized when logging in.
	// But, it just looks good to me. :-)
	setregged(id, false)

	g_groupflags[id] = 0

	// This is needed though
	//g_authorized[id] = false
	setauthorized(id, false)

	return PLUGIN_CONTINUE
}

public checkreg_cmd(id) {
	const LEN = 32
	new authid[LEN + 1], namefromdb[32], initialname[32]

	get_user_authid(id, authid, LEN)
	get_user_name(id, initialname, 31)

	setregged(id, initialcheckreg2(id, authid, namefromdb))
	if (regged(id)) {
		console_print(id, "Yes, you are registered as %s in forums.", namefromdb)

		//console_print(id, "checkreg_cmd, initialname: %s, namefromdb: %s", initialname, namefromdb)
		//server_print("checkreg_cmd, initialname: %s, namefromdb: %s", initialname, namefromdb)
		// Make sure forum name is used
		//set_user_info(id, "name", name)
		if (get_cvar_num(CVAR_FORCEFORUMNAME))
			force_forumname(id, initialname, authid)
	}
	else {
		console_print(id, "No, you aren't registered.")
		// Make sure pub name is used.
		force_pubname(id, initialname, 31, authid)
	}

	return PLUGIN_HANDLED
}


public reggroup_cmd(id, level, cid) {
	if (!cmd_access(id, level, cid, 3))
		return PLUGIN_HANDLED

	if (!g_initialized) {
		//server_print("[%s] ERROR when registering group - Plugin has not yet initialized!", PLUGINNAME)
		return PLUGIN_HANDLED
	}

	if (g_groupsCount + 1 > MAXGROUPS) {
		log_amx("[%s] ERROR when registering group - Maximum number of groups reached! (%d)", PLUGINNAME, MAXGROUPS)
		return PLUGIN_HANDLED
	}

	new stringbuffer[MAXGROUPNAMESIZE + 2]

	read_argv(1, stringbuffer, MAXGROUPNAMESIZE + 1)
	if (strlen(stringbuffer) > MAXGROUPNAMESIZE) {
		log_amx("[%s] ERROR when registering group - Group name too long. Maximum of %d characters allowed. %d were used.", PLUGINNAME, MAXGROUPNAMESIZE, strlen(stringbuffer))
		return PLUGIN_HANDLED
	}

	// Make sure name isn't already registered.
	for (new i = 0; i < g_groupsCount; i++) {
		if (equali(stringbuffer, g_groupsTitles[i])) {
			server_print("[%s] ERROR when registering group ^"%s^" - Group ^"%s^" is already registered!", PLUGINNAME, stringbuffer, g_groupsTitles[i])
			return PLUGIN_HANDLED
		}
	}

	// Make sure group exists in db. Retrieve its group id (phpBB, IPB)
	new Sql:sql
	if (!fm_db_connect(sql)) {
		log_amx("Failed connecting to database to look up group when trying to register it! Check your database/database user settings.")
		return PLUGIN_HANDLED
	}
	new query[256]
	format(query, 255, "SELECT `%s` FROM `%s` WHERE `%s` = ^"%s^"", g_FIELD_GROUPS_ID, g_TABLE_GROUPS, g_FIELD_GROUPS_TITLE, stringbuffer)
	new Result:result = dbi_query(sql, query)
	if (result < RESULT_NONE) {
		new sqlerror[256]
		dbi_error(sql, sqlerror, 255)
		log_amx("Error while quering SQL db for group during group registration: %s", sqlerror)
		dbi_close(sql)
		return PLUGIN_HANDLED
	}
	new const ROWS = dbi_num_rows(result)

	if (ROWS == 0) {
		log_amx("No group exists in forum database with the name ^"%s^"!", stringbuffer)
		dbi_close(sql)
		return PLUGIN_HANDLED
	}
	else if (ROWS > 1) {
		log_amx("ERROR in forum database - more than one group in forum database match the name ^"%s^"! (%d)", stringbuffer, ROWS)
		dbi_free_result(result)
		dbi_close(sql)
		return PLUGIN_HANDLED
	}
	dbi_nextrow(result)

	new groupId = dbi_field(result, 1)
	dbi_free_result(result)
	dbi_close(sql)

	format(g_groupsTitles[g_groupsCount], MAXGROUPNAMESIZE, stringbuffer)

	read_argv(2, stringbuffer, MAXGROUPNAMESIZE + 1)
	g_groupsAccess[g_groupsCount] = read_flags(stringbuffer)
	g_groupsIds[g_groupsCount] = groupId

	get_flags(g_groupsAccess[g_groupsCount], stringbuffer, MAXGROUPNAMESIZE + 1)

	server_print("[%s] Registered group ^"%s^". Members of this group will have these extra access flags: ^"%s^"."/* Group is number #%d in SQL database."*/, PLUGINNAME, g_groupsTitles[g_groupsCount], stringbuffer, g_groupsIds[g_groupsCount])
	g_groupsCount++

	return PLUGIN_HANDLED
}

public listgroup_cmd(id, level, cid) {
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED

	new flags[64]
	console_print(id, "[%s] %d group%s registered", PLUGINNAME, g_groupsCount, g_groupsCount == 1 ? " is" : "s are")

	for (new i = 0; i < g_groupsCount; i++) {
		get_flags(g_groupsAccess[i], flags, 63)
		console_print(id, "%d: ^"%s^" Access flags: ^"%s^" Group DB: #%d", i + 1, g_groupsTitles[i], flags, g_groupsIds[i])
	}

	return PLUGIN_HANDLED
}

#if defined CS_STATS_EXPORT_TO_FORUM
public plugin_end() {
	// Export all player stats to forum db
	if (get_cvar_num("csstats_reset") == 1)
		reset_stats()
	else
		export_stats()
}

reset_stats() {
	server_print("[%s] Resetting all player stats in forum database...", PLUGINNAME)
	new Sql:sql
	if (!fm_db_connect(sql)) {
		log_amx("Failed connecting to forum database when trying to reset player stats! Check your settings.")
		return
	}

	new query[2048], len
	len = format(query, 2047, "UPDATE `%s` SET `stats_timestamp` = %d, `stats_tks` = %d, `stats_damage` = %d, `stats_deaths` = %d, ", g_TABLE_USERS, 0, 0, 0, 0)
	len += format(query[len], 2047 - len, "`stats_frags` = %d, `stats_shots` = %d, `stats_hits` = %d, `stats_hs` = %d, `stats_rank` = %d, ", 0, 0, 0, 0, 0)
	len += format(query[len], 2047 - len, "`stats_bodyhits0` = %d, `stats_bodyhits1` = %d, `stats_bodyhits2` = %d, ", 0, 0, 0)
	len += format(query[len], 2047 - len, "`stats_bodyhits3` = %d, `stats_bodyhits4` = %d, `stats_bodyhits5` = %d, ", 0, 0, 0)
	len += format(query[len], 2047 - len, "`stats_bodyhits6` = %d, `stats_bodyhits7` = %d, ", 0, 0)
	len += format(query[len], 2047 - len, "`stats_defusions` = %d, `stats_defused` = %d, `stats_plants` = %d, `stats_explosions` = %d, ", 0, 0, 0, 0)
	len += format(query[len], 2047 - len, "`stats_efficiency` = %f, `stats_accuracy` = %f ", 0.0, 0.0)

	new Result:result = dbi_query(sql, query)

	if (result < RESULT_NONE) {
		new sqlerror[256]
		dbi_error(sql, sqlerror, 255)
		log_amx("UPDATE query error when trying to reset stats in forum: %s", sqlerror)
		dbi_close(sql)
		return
	}
	else
		server_print("[%s] Done!", PLUGINNAME)

	dbi_close(sql)
}


export_stats() {
	new const TIMESTAMP = get_systime()
	server_print("[%s] Exporting player stats to forum database...", PLUGINNAME)

	new Sql:sql
	if (!fm_db_connect(sql)) {
		log_amx("Failed connecting to forum database when trying to update player stats! Check your settings.")
		return
	}

	// Get what data should be displayed in forum. Those that shouldn't get displayed are replaced with 0 which the forum shouldn't display...
	new statsflags[64]
	get_cvar_string(CVAR_STATS, statsflags, 63)
	new const STATS = read_flags(statsflags)

	new const TKS = STATS & (1 << DISPLAY_TKS)
	new const DAMAGE = STATS & (1 << DISPLAY_DAMAGE)
	new const DEATHS = STATS & (1 << DISPLAY_DEATHS)
	new const FRAGS = STATS & (1 << DISPLAY_FRAGS)
	new const SHOTS = STATS & (1 << DISPLAY_SHOTS)
	new const HITS = STATS & (1 << DISPLAY_HITS)
	new const HS = STATS & (1 << DISPLAY_HS)
	new const DEFUSIONS = STATS & (1 << DISPLAY_DEFUSIONS)
	new const DEFUSED = STATS & (1 << DISPLAY_DEFUSED)
	new const PLANTS = STATS & (1 << DISPLAY_PLANTS)
	new const EXPLOSIONS = STATS & (1 << DISPLAY_EXPLOSIONS)
	new const RANK = STATS & (1 << DISPLAY_RANK)
	new const EFFICIENCY = STATS & (1 << DISPLAY_EFFICIENCY)
	new const ACCURACY = STATS & (1 << DISPLAY_ACCURACY)


	new stats[8], bodyhits[8], name[32], authid[32], bombstats[4] // get_stats(index,stats[8],bodyhits[8],name[],len,authid[],authidlen=0);
	new query[2048], len, Result:result, updateCount = 0
	new i = 0, records
	do {
		get_stats2(i, bombstats)
		i = get_stats(i, stats, bodyhits, name, 31, authid, 31)

		// No laners (?) or bots...
		// Also make sure this is really a valid steamid an dnot something else. The first 8 characters should be "STEAM_0:".
		// A steamid looks like something of this form: STEAM_0:#:####### (the first # seems to be 1 or 0 always)
		if (equal(authid, "STEAM_ID_PENDING") || equal(authid, "BOT") || !equal(authid, "STEAM_0:", 8))
			continue

		// Does this authid exist in forum user table?
		format(query, 2047, "SELECT `%s`, `%s` FROM `%s` WHERE `%s` = ^"%s^"", g_FIELD_USERS_USERID, g_FIELD_USERS_NAME, g_TABLE_USERS, g_FIELD_USERS_STEAMID, authid)

		result = dbi_query(sql, query)
		if (result < RESULT_NONE) {
			new sqlerror[256]
			dbi_error(sql, sqlerror, 255)
			log_amx("SELECT query error regarding ^"%s^". Further updating of stats halted: %s", authid, sqlerror)
			break
		}

		records = dbi_num_rows(result)

		if (records == 0) {
			//server_print("[%s] Not in forum: %s", PLUGINNAME, authid)
			continue
		}
		else if (records > 1) {
			log_amx("WARNING: %d different forum members have entered ^"%s^" into their profiles! Not updating their stats. Their forum ids and names follow, hunt those bastards down! ;-)", records, authid)

			new forumname[32], forumid
			new v = 1, length = 0
			while (records >= v) {
				if (++length == 9)
					break
				v *= 10
			}
			new form[] = "[%s] %xd: %s"
			form[6] = length + 48

			//server_print("length = %d, form[7] = %c", length, form[7])
			while ((dbi_nextrow(result))) {
				forumid = dbi_field(result, 1)
				dbi_field(result, 2, forumname, 31)
				log_amx(form, PLUGINNAME, forumid, forumname)
			}

			dbi_free_result(result)
			continue
		}
		dbi_free_result(result)

		// This far we have exactly one occurance of this steamid in forums usertable. Update that record.
		len = format(query, 2047, "UPDATE `%s` SET `stats_timestamp` = %d, `stats_tks` = ^"%d^", `stats_damage` = ^"%d^", `stats_deaths` = ^"%d^", ", g_TABLE_USERS, TIMESTAMP, !TKS ? 0 : stats[STATS_TKS], !DAMAGE ? 0 : stats[STATS_DAMAGE], !DEATHS ? 0 : stats[STATS_DEATHS])
		len += format(query[len], 2047 - len, "`stats_frags` = ^"%d^", `stats_shots` = ^"%d^", `stats_hits` = ^"%d^", `stats_hs` = ^"%d^", `stats_rank` = ^"%d^", ", !FRAGS ? 0 : stats[STATS_KILLS], !SHOTS ? 0 : stats[STATS_SHOTS], !HITS ? 0 : stats[STATS_HITS], !HS ? 0 : stats[STATS_HS], !RANK ? 0 : stats[STATS_RANK])
		len += format(query[len], 2047 - len, "`stats_bodyhits0` = ^"%d^", `stats_bodyhits1` = ^"%d^", `stats_bodyhits2` = ^"%d^", ", bodyhits[0], bodyhits[1], bodyhits[2])
		len += format(query[len], 2047 - len, "`stats_bodyhits3` = ^"%d^", `stats_bodyhits4` = ^"%d^", `stats_bodyhits5` = ^"%d^", ", bodyhits[3], bodyhits[4], bodyhits[5])
		len += format(query[len], 2047 - len, "`stats_bodyhits6` = ^"%d^", `stats_bodyhits7` = ^"%d^", ", bodyhits[6], bodyhits[7])
		len += format(query[len], 2047 - len, "`stats_defusions` = ^"%d^", `stats_defused` = ^"%d^", `stats_plants` = ^"%d^", `stats_explosions` = ^"%d^", ", !DEFUSIONS ? 0 : bombstats[BOMBSTATS_DEFUSIONS], !DEFUSED ? 0 : bombstats[BOMBSTATS_DEFUSED], !PLANTS ? 0 : bombstats[BOMBSTATS_PLANTS], !EXPLOSIONS ? 0 : bombstats[BOMBSTATS_EXPLOSIONS])
		len += format(query[len], 2047 - len, "`stats_efficiency` = ^"%f^", `stats_accuracy` = ^"%f^"", !EFFICIENCY ? 0.0 : calculate_efficiency(stats[STATS_KILLS], stats[STATS_DEATHS]), !ACCURACY ? 0.0 : calculate_accuracy(stats[STATS_SHOTS], stats[STATS_HITS]))
		len += format(query[len], 2047 - len, "WHERE `%s` = ^"%s^" LIMIT 1", g_FIELD_USERS_STEAMID, authid)

		result = dbi_query(sql, query)

		if (result < RESULT_NONE) {
			new sqlerror[256]
			dbi_error(sql, sqlerror, 255)
			log_amx("UPDATE query error regarding ^"%s^". Further updates halted: %s", authid, sqlerror)
			break
		}
		else {
			updateCount++
			//server_print("[%s] Exported %s ranked %d.", PLUGINNAME, authid, stats[STATS_RANK])
		}

	} while (i)

	dbi_close(sql)
	server_print("[%s] Done! Forum accounts updated: %d", PLUGINNAME, updateCount)
}

Float:calculate_efficiency(const FRAGS, const DEATHS) {
	if (!FRAGS)
		return 0.0

	return ( 100.0 * float( FRAGS ) / float( FRAGS + DEATHS ) )
}

Float:calculate_accuracy(const SHOTS, const HITS) {
	if ( !SHOTS )
		return 0.0

	return ( 100.0 * float( HITS ) / float( SHOTS ) )
}
#endif // CS_STATS_EXPORT_TO_FORUM

public plugin_init() {
	register_plugin(PLUGINNAME, VERSION, AUTHOR)

	//register_event("DeathMsg", "death_event", "a")

	//register_clcmd("say mytime", "sayMyTime", FMACCESS, "- displays your current time")
	register_srvcmd("amx_registergroup", "reggroup_cmd", 0, "<group name> <flags> - registers a group")
	register_concmd("amx_listgroups", "listgroup_cmd", 0, "- lists registered groups")
	register_clcmd("amx_checkreg", "checkreg_cmd", 0, "- checks with database if you are regged")

	register_cvar(CVAR_HOST, "127.0.0.1")
	register_cvar(CVAR_USER, "")
	register_cvar(CVAR_PASS, "")
	register_cvar(CVAR_DB, "YOU FORGOT TO SET THIS CVAR YOU... YOU.... PIRATE!!!")
	register_cvar(CVAR_KICKNONREGGED, "1")
	register_cvar(CVAR_REGURL, "")
	register_cvar(CVAR_PREPEND, "Pub:")
	register_cvar(CVAR_APPEND, "")
	register_cvar(CVAR_FORCEFORUMNAME, "1")
	register_cvar(CVAR_REGACCESS, "bm")
	register_cvar(CVAR_FORUMURL, "")
	register_cvar(CVAR_TIMEZONE, "0")

	register_cvar(CVAR_STATS, "cdgiklmn")

	register_message(get_user_msgid("SayText"), "message_saytext")

	new sqlcfgpath[128]
	get_configsdir(sqlcfgpath, 127)
	format(sqlcfgpath, 127, "%s/sql.cfg", sqlcfgpath)
	server_cmd("exec %s", sqlcfgpath)
	server_exec() // To force execution of above cmd before progress? seems to do the trick...

	// Try a connect here just to make sure db connection is functional.
	new Sql:sql
	if (!fm_db_connect(sql)) {
		log_amx("[%s] !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", PLUGINNAME)
		log_amx("[%s] Failed connecting to database! Check your settings. Pausing plugin.", PLUGINNAME)
		log_amx("[%s] !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", PLUGINNAME)
		pause("a")
		return
	}
	else
		server_print("[%s] Connected successfully to SQL database.", PLUGINNAME)

	g_initialized = true

	dbi_close(sql)

#if defined ALLOWREADINGMAIL
	register_menucmd(register_menuid("You have"), MENUBUTTON1|MENUBUTTON2, "messages_fn")
	register_menucmd(register_menuid("browsingsubjects"), 1023, "subjects_fn")
	register_clcmd("amx_readmail", "readmail_fn", FMACCESS, "- read your forum mail")
	if (!cstrike_running()) {
		for (new i = 0; i < NROFMAILTYPES; i++)
			copy(g_MAILTYPES[i], 19, g_MAILTYPES_NOCOLOURS[i])
	}
#endif // defined ALLOWREADINGMAIL
}

